-- MySQL dump 10.9
--
-- Host: localhost    Database: yrgate
-- ------------------------------------------------------
-- Server version	4.1.9-standard

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE="NO_AUTO_VALUE_ON_ZERO" */;

--
-- Table structure for table `admin_session`
--

DROP TABLE IF EXISTS `admin_session`;
CREATE TABLE `admin_session` (
  `sid` int(10) NOT NULL auto_increment,
  `USERid` text,
  `uid` varchar(20) default NULL,
  `checked_out_date` text,
  `geneName` varchar(20) default NULL,
  `dbName` varchar(20) default NULL,
  `returned` tinyint(1) default '0',
  PRIMARY KEY  (`sid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `admin_session`
--


/*!40000 ALTER TABLE `admin_session` DISABLE KEYS */;
LOCK TABLES `admin_session` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `admin_session` ENABLE KEYS */;

--
-- Table structure for table `user_gene_annotation`
--

DROP TABLE IF EXISTS `user_gene_annotation`;
CREATE TABLE `user_gene_annotation` (
  `uid` int(10) unsigned NOT NULL auto_increment,
  `USERid` varchar(50) NOT NULL default '',
  `geneId` varchar(32) NOT NULL default '',
  `chr` varchar(45) default NULL,
  `strand` enum('f','r') NOT NULL default 'f',
  `l_pos` int(10) unsigned NOT NULL default '0',
  `r_pos` int(10) unsigned NOT NULL default '0',
  `gene_structure` text NOT NULL,
  `description` text,
  `comment` text,
  `CDSstart` int(20) unsigned default NULL,
  `CDSstop` int(20) unsigned default NULL,
  `proteinId` varchar(32) default NULL,
  `geneAliases` text,
  `proteinAliases` text,
  `status` varchar(32) NOT NULL default 'HOLD',
  `modDate` datetime default NULL,
  `evidence` text,
  `underReview` datetime default NULL,
  `annotation_type` varchar(20) default NULL,
  `mRNAseq` text,
  `proteinseq` text,
  `GSeqEdits` text,
  `organism` varchar(32) default NULL,
  `dbName` varchar(45) default NULL,
  `dasCookie` text,
  `dbVer` varchar(20) default NULL,
  PRIMARY KEY  (`uid`),
  UNIQUE KEY `uniq_geneId` (`geneId`),
  FULLTEXT KEY `ugaFT_DescComm` (`description`,`comment`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `user_gene_annotation`
--


/*!40000 ALTER TABLE `user_gene_annotation` DISABLE KEYS */;
LOCK TABLES `user_gene_annotation` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `user_gene_annotation` ENABLE KEYS */;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
CREATE TABLE `users` (
  `uid` int(10) NOT NULL auto_increment,
  `user_name` varchar(50) default NULL,
  `pword` blob NOT NULL,
  `account_type` enum('USER','ADMIN') NOT NULL default 'USER',
  `fullname` varchar(50) NOT NULL default '',
  `email` varchar(100) default NULL,
  `phone` varchar(30) default NULL,
  PRIMARY KEY  (`uid`),
  UNIQUE KEY `user_name` (`user_name`),
  UNIQUE KEY `email` (`email`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `users`
--


/*!40000 ALTER TABLE `users` DISABLE KEYS */;
LOCK TABLES `users` WRITE;
INSERT INTO `users` VALUES (1,'testuser','','USER','test user',NULL,NULL),(2,'testadmin','','ADMIN','test admin',NULL,NULL);
UNLOCK TABLES;
/*!40000 ALTER TABLE `users` ENABLE KEYS */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;

