#!/usr/bin/perl


init_xgdb();

sub init_xgdb{
  # initiazes global values for xgdb implementation, add from xgdb cookie
    
    # temporary fix to use length of genome segment
    if (length($PRM->{chr}) >= 3 ){
	$GV->{altCONTEXT} = "BAC";
	$GV->{blastDB} = $GV->{altblastDB};
        $GV->{CHR_SELECT_BOX} = 0;
    }else{
	$GV->{altCONTEXT} = "chr";
	$GV->{blastDB} = "GENOME";
    }

  return;
}

sub getGenomeSequence_xgdb{
  my $seq;
  my $link = "$GV->{rootPATH}$GV->{SSIpath}/returnFASTA.pl?db=$GV->{blastDB}&dbid=$GV->{dbid}&hits=$PRM->{chr}:$PRM->{start}:$PRM->{end}";
  print STDERR $link;
  my $seq = get($link);
  $seq =~ s/.+?<pre>>.+?\n//is;  # remove all html up to defline
  $seq =~ s/<\/pre>.+//is; # remove trailing html
  $seq =~ s/\W//sg; # remove all line breaks
  return $seq;
}

sub getImageMap_xgdb{
  # returns image html + image map + scale variable
    init_xgdb();
    my $link = $GV->{rootPATH}.$GV->{SSIpath}."UCAimage.pl?l_pos=$PRM->{start}&r_pos=$PRM->{end}&dbid=$GV->{dbid}&imgWidth=$PRM->{imgWidth}";
    $link .=  ($GV->{altCONTEXT} eq "BAC") ? "&gseg_gi=$PRM->{chr}&altCONTEXT=$GV->{altCONTEXT}" : "&chr=$PRM->{chr}";

    print STDERR $link;
    my $imagelinkALL = get("${link}"); 
    return $imagelinkALL;
}


sub getScale_xgdb{
my $zeroPos = int($PRM->{start});
my $StartX=20;
my $Margin=10;
my $imgWidth = $PRM->{imgWidth};
  my $unit=1000;
  my $len=$PRM->{end}-$PRM->{start}+1;
  if($len<1000){
    $unit=10;
  }elsif($len<10000){
    $unit=100;
  }
#my   $zeroPos = int($start); # change to local
my $seqLen = $PRM->{end} - $zeroPos + 1;
my $ratio=$seqLen/($PRM->{imgWidth}-$StartX-2*$Margin);
my $rulerLen=$seqLen/$ratio;
my $scale=$seqLen/$rulerLen;
$scale = sprintf("%.2f", $scale);

return ($scale,$zeroPos,$StartX,$Margin); # [base to pixel scale] , [base position of start of graphic], [left padding white space in graphic]
}



sub GenomeContextLink_xgdb{
  my ($chr,$lp,$rp,$dbVer) = @_;
  my $link = "$GV->{rootPATH}$GV->{SSIpath}";
  $link .= (length($chr) <= 2) ? "getRegion.pl?dbid=$dbVer&chr=$chr&l_pos=$lp&r_pos=$rp" : "getGSEG_Region.pl?dbid=$dbVer&gseg_gi=$chr&l_pos=$lp&r_pos=$rp" ;
  return $link;
}

1;
