#!/usr/bin/perl
#use strict "vars";

use vars qw(
$GV
$GVportal
$PRM
@modes
$DBH
$zeroPos
$UCAcgiPATH
$IMAGEDIR
$GENSCAN_speciesModel
	    );

require 'yrGATE_conf.pl';
require 'yrGATE_functions.pl';

&{$GV->{InitFunction}};

$PRM->{USERid} = &{$GV->{getUserIdFunction}};
$PRM->{owner}  = param('owner') ? param('owner') : $PRM->{USERid}; # ?

if(!$PRM->{USERid}){
  ## Request user login for annotation creation
  bailOut("You must login first before using this tool. $GV->{dbTitle}");
}
my $isAdmin = getUserGroup($PRM->{USERid});

if ($isAdmin){  # only display page for admins
  
  my $geneId = param('mode'); # geneId to checkout
  my $uid = param('uid'); # uid to return 
  
  
  if ($geneId){
    
    $openV = param('openV');
    #check out annotation
    $sql = "insert into admin_session (USERid,uid,checked_out_date,dbName) VALUES ('$PRM->{USERid}','$geneId',now(),'$GV->{dbTitle}')";
    $GV->{LDBH}->do($sql); 
    
  }
  my $ownedRef = getAdminOwnership();
  if ($$ownedRef{$uid} eq  $PRM->{USERid}){
    $sql = "update admin_session set returned = 1 where uid = $uid and USERid = '$PRM->{USERid}'";
    $GV->{LDBH}->do($sql);
    $ownedRef = getAdminOwnership(); # new ownership
  }
  
  
  $sql = "select uid,geneId,modDate,status,USERid,chr,l_pos,r_pos,dbVer from user_gene_annotation where status != 'SAVED' and dbName = '$GV->{dbTitle}' order by status, modDate desc";
  $UCAref = $GV->{ADBH}->selectall_arrayref($sql);

  for (my $i=0;$i<scalar(@$UCAref);$i++){
    my ($uid,$geneId,$modDate,$status,$owner,$chr,$start,$end,$dbVer) = @{$UCAref->[$i]}; 
#    my $UCAtablerow = "<td>$owner</td><td>$modDate</td><td>(&{$GV->{GenomeContextLinkFunction}}($chr,$start,$end,$dbVer))</td><td>$$ownedRef{$uid}";
    if (!$$ownedRef{$uid}){
      push(@{$statusHash{$status}},"<tr><td class='myLink'><a  target=\"_blank\" onClick=\"checkout('$uid');\">$geneId </a></td><td>$owner</td><td>$modDate</td><td><a target='_blank' href='".(&{$GV->{GenomeContextLinkFunction}}($chr,$start,$end,$dbVer))."'>$chr $start $end</a></td><td>$$ownedRef{$uid}</td></tr>\n");
    }elsif ($$ownedRef{$uid} eq $PRM->{USERid}){
      push(@{$statusHash{$status}},"<tr><td class='myLink'><a  target=\"_blank\" onClick=\"checkout('$uid');\">$geneId </a></td><td>$owner</td><td>$modDate</td><td><a target='_blank' href='".(&{$GV->{GenomeContextLinkFunction}}($chr,$start,$end,$dbVer))."'>$chr $start $end</a></td><td>$$ownedRef{$uid}<br><a href='${rootPATH}${CGIPATH}AnnotationTool.pl?uid=$uid' target='_blank'>Administrate Annotation</a><br><a href='${rootPATH}${CGIPATH}AdminAnnotation.pl?uid=$uid&return=1'>Return Annotation</a></td></tr>\n");
    }else{
      push(@{$statusHash{$status}},"<tr class='checked'><td>$geneId</td><td>$owner</td><td>$modDate</td><td><a target='_blank' href='".(&{$GV->{GenomeContextLinkFunction}}($chr,$start,$end,$dbVer))."'>$chr $start $end</a></td><td>$$ownedRef{$uid}</td></tr>\n");
    }
  }

  my $page = printTitle("Administration Tool",1,1);

  $page .= "Click on an Annotation ID to check it out for administration.  This will grant you exclusive permission to administrate the annotation for 30 minutes.  To administrate a checked out annotation, use the Administration Tool which opens in a new window open clicking the annotation ID if your browser accepts popups, or click on the link 'Administrate Annotation'.<br><br>";
  
  my $status = '';

  my $table = "<table class=mainT border=1><tr class='headRow'><td>Annotation ID</td><td>Owner</td><td>Last Modified</td><td>Chromosome</td><td>Checked out by Admin?</td></tr>\n";
  foreach $status (sort {return $b cmp $a} keys %statusHash){
    $table .= "<tr><td colspan = 5 bgcolor=lightblue><b>$status</b></td></tr>";
    $table .= 	join("\n", @{$statusHash{$status}});
  }
  $table .= "</table>\n";

  $page .= $table;

print header();

$HTML_head = <<END_OF_HEAD;
<html>
<head>
<title>yrGATE Administration Tool: Annotation Check Out Page</title>
<LINK type='text/css' rel='stylesheet' href='$GV->{HTMLPATH}yrGATE.css'>
<script>

function checkout(id){
   Sname = id;
   illChar = new RegExp("[-_\s\.]","g");
   Sname = Sname.replace(illChar,"");
   document.forms.tFrm.mode.value = id;
   document.forms.tFrm.openV.value = 1;
   document.forms.tFrm.submit();
   return;
}

function openANN(){
   if (document.forms.tFrm.openV.value == 1){
     document.forms.tFrm.openV.value = 0;
     window.open("AnnotationTool.pl?uid=" + '$geneId', 'UCA' + '$geneId', 'resizable=yes,screenX=100,screenY=100,top=100,left=100,toolbar=no,status=yes,scrollbars=yes,location=yes,menubar=no,directories=no,width=800,height=600');
   }
}
</script>
</head>

<body onLoad="openANN();"><form name='tFrm' method=post><input type=hidden name=mode value="">$mode
END_OF_HEAD

print $HTML_head;

print $page;
print "<input type=submit value='Reload Page'><br><input type=hidden name='openV' value=$openV>";
print "</form>".printFooter()."</body></html>";

}else{
    print header();
    print "Action not allowed.";

}

    disconnectDB();
