#!/usr/bin/perl
#use strict "vars";

use vars qw(
$GV
$GVportal
$PRM
@modes
$DBH
$zeroPos
$UCAcgiPATH
$IMAGEDIR
$GENSCAN_speciesModel
);

require 'yrGATE_conf.pl';
require 'yrGATE_functions.pl';

&{$GV->{InitFunction}};

# replace with check login
$PRM->{USERid} = &{$GV->{getUserIdFunction}};
if(!$PRM->{USERid}){
  bailOut("You must login first before using this tool. $GV->{dbTitle}");
}


## sort fields
$PRM->{sort_f} = param('sort_f');
my $newsort = param('new_sort');

if ($PRM->{sort_f} eq ""){
    $PRM->{sort_f} = "status, modDate";
}

if ($PRM->{sort_f} !~ /$newsort/ && $newsort ne ""){
    $PRM->{sort_f} = $newsort.", ".$PRM->{sort_f};
}elsif ($newsort ne ""){
    $PRM->{sort_f} =~ s/$PRM->{sort_f}\,*//;
    $PRM->{sort_f} = $newsort.",".$PRM->{sort_f};
}


my @statusArr = ('SUBMITTED_FOR_REVIEW','SAVED','ACCEPTED','REJECTED');
my $sql = "select uid,geneId,modDate,status,USERid,chr,l_pos,r_pos,proteinseq,organism,dbName,dbVer from user_gene_annotation where USERid = '$PRM->{USERid}' and dbName = '$GV->{dbTitle}' order by $PRM->{sort_f} desc";
my $UCAref = $GV->{ADBH}->selectall_arrayref($sql);
my $table = recordTable($UCAref,\@statusArr);


$titleHead .= printTitle("Annotator Account",1,1);


$page = "$titleHead$table";

$page .= "Download all annotations owned by $PRM->{USERid}:<br>";
$page .= "<a $linkTarget href='$GV->{CGIPATH}AnnotationExport.pl?amt=user&html=1&format=fasta&html=1&seqType=n'> Nucleotide FASTA</a><br><a $linkTarget href='$GV->{CGIPATH}AnnotationExport.pl?amt=user&html=1&format=fasta&html=1&seqType=p'> Protein FASTA</a><br><a $linkTarget href='$GV->{CGIPATH}AnnotationExport.pl?amt=user&html=1&format=gff3&html=1'>GFF3</a>";

print header();
print "
<html>
<head>
<title>yrGATE: Annotation Account</title>
<LINK type='text/css' rel='stylesheet' href='$GV->{HTMLPATH}yrGATE.css'>
</head>

<body class=mainT>
<form name='tFrm' method=post>
$page
<br><br>
<input type=hidden name='sort_f' value='$PRM->{sort_f}'>
</form>".printFooter()."</body>
</html>";

disconnectDB();
