#!/usr/bin/perl
#use strict "vars";

use vars qw(
$GV
$GVportal
$PRM
@modes
$DBH
$zeroPos
$UCAcgiPATH
$IMAGEDIR
$GENSCAN_speciesModel
);

require 'yrGATE_conf.pl';
require 'yrGATE_functions.pl';

&{$GV->{InitFunction}};

if (!$GV->{login_required} && $GV->{dasInput}){
    print redirect("das_scripts/dasSelect.pl");
}


my @statusArr = ('ACCEPTED');
my $sql = "select uid,geneId,modDate,status,USERid,chr,l_pos,r_pos,proteinSeq,organism,dbName,dbVer from user_gene_annotation where status='ACCEPTED' and dbName = '$GV->{dbTitle}' order by status, modDate desc";
my $UCAref = $GV->{ADBH}->selectall_arrayref($sql);
my $table = recordTable($UCAref,\@statusArr);


$titleHead .= printTitle("Community Annotation Central",1,1);

$page = "$titleHead<br>Community Annotations<br>$table";

my $download .= "Download all annotations:<br>";
$download .= "<a $linkTarget href='$GV->{CGIPATH}AnnotationExport.pl?amt=all&html=1&format=fasta&html=1&seqType=n'> Nucleotide FASTA</a>&nbsp&nbsp <a $linkTarget href='$GV->{CGIPATH}AnnotationExport.pl?amt=all&html=1&format=fasta&html=1&seqType=p'> Protein FASTA</a>&nbsp&nbsp<a $linkTarget href='$GV->{CGIPATH}AnnotationExport.pl?amt=all&html=1&format=gff3&html=1'>GFF3</a>";

my $parent_fresh = (param('login') or param('logout')) ? "<script>top.opener.location.href = top.opener.location.href;</script>" : "";  # refreshes parent window

print header();
print "
<html>
<head>
<title>yrGATE: Community Annotation Central</title>
<LINK type='text/css' rel='stylesheet' href='$GV->{HTMLPATH}yrGATE.css'>
</head>

<body class=mainT>
$parent_fresh
<form name='tFrm' method=post>
$titleHead
<br>Community Annotations<br>
$table
$download

<br><br>
Sample Genome Entry:<br>
$GV->{sampleEntryLink}


</form>
".printFooter()."
</body>
</html>";

disconnectDB();
